//SGSGWrench.cs
$TotalMoversInGroup = 5;
//effects
datablock ParticleData(SGWrenchExplosionParticle)
{
   dragCoefficient      = 5;
   gravityCoefficient   = 0.0;
   inheritedVelFactor   = 0.2;
   constantAcceleration = 0.0;
   lifetimeMS           = 500;
   lifetimeVarianceMS   = 300;
   textureName          = "~/data/particles/snowflake";
   colors[0]     = "0.0 0.7 0.9 0.9";
   colors[1]     = "0.0 0.0 0.9 0.0";
   sizes[0]      = 0.7;
   sizes[1]      = 0.2;
};

datablock ParticleEmitterData(SGWrenchExplosionEmitter)
{
   ejectionPeriodMS = 7;
   periodVarianceMS = 0;
   ejectionVelocity = 5;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 60;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "SGWrenchExplosionParticle";
};

datablock ExplosionData(SGWrenchExplosion)
{
   //explosionShape = "";
   lifeTimeMS = 500;

   particleEmitter = SGWrenchExplosionEmitter;
   particleDensity = 10;
   particleRadius = 0.2;

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = true;
   camShakeFreq = "2.0 2.0 2.0";
   camShakeAmp = "1.0 1.0 1.0";
   camShakeDuration = 0.5;
   camShakeRadius = 10.0;

   // Dynamic light
   lightStartRadius = 3;
   lightEndRadius = 1;
   lightStartColor = "00.0 0.6 0.9";
   lightEndColor = "0 0 0";
};


//projectile
datablock ProjectileData(SGWrenchProjectile)
{
   //projectileShapeName = "~/data/shapes/arrow.dts";
   directDamage        = 10;
   radiusDamage        = 10;
   damageRadius        = 0.5;
   explosion           = SGWrenchExplosion;
   //particleEmitter     = as;

   muzzleVelocity      = 50;
   velInheritFactor    = 1;

   armingDelay         = 0;
   lifetime            = 100;
   fadeDelay           = 70;
   bounceElasticity    = 0;
   bounceFriction      = 0;
   isBallistic         = false;
   gravityMod = 0.0;

};


//////////
// item //
//////////
datablock ItemData(SGWrench)
{
	category = "stargate";  // Mission editor category
	className = "Tool"; // For inventory system

	 // Basic Item Properties
	shapeFile = "~/data/shapes/SGWrench.dts";
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;
        skinName = 'black';
	cost = "60";
	 // Dynamic properties defined by the scripts
	pickUpName = 'a Stargate Wrench';
	invName = 'Stargate Wrench';
	image = SGWrenchImage;
};

//function SGWrench::onUse(%this,%user)
//{
//	//mount the image in the right hand slot
//	%user.mountimage(%this.image, $RightHandSlot);
//}

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(SGWrenchImage)
{
   // Basic Item properties
   shapeFile = "~/data/shapes/SGWrench.dts";
   PreviewFileName = "rtb/data/shapes/bricks/Previews/Wrench.png";
   emap = true;
	cloakable = false;
   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   //eyeOffset = "0.1 0.2 -0.55";

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = false;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = SGWrench;
   ammo = " ";
   projectile = SGWrenchProjectile;
   projectileType = Projectile;
	
   //melee particles shoot from eye node for consistancy
   melee = true;
   //raise your arm up or not
   armReady = true;

   //casing = " ";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 0.5;
	stateTransitionOnTimeout[0]       = "Ready";

	stateName[1]                     = "Ready";
	stateTransitionOnTriggerDown[1]  = "PreFire";
	stateAllowImageChange[1]         = true;

	stateName[2]			= "PreFire";
	stateScript[2]                  = "onPreFire";
	stateAllowImageChange[2]        = false;
	stateTimeoutValue[2]            = 0.1;
	stateTransitionOnTimeout[2]     = "Fire";

	stateName[3]                    = "Fire";
	stateTransitionOnTimeout[3]     = "CheckFire";
	stateTimeoutValue[3]            = 0.2;
	stateFire[3]                    = true;
	stateAllowImageChange[3]        = false;
	stateSequence[3]                = "Fire";
	stateScript[3]                  = "onFire";
	stateWaitForTimeout[3]		= true;
	//stateTransitionOnTriggerUp[3]	= "StopFire";

	stateName[4]			= "CheckFire";
	stateTransitionOnTriggerUp[4]	= "StopFire";
	stateTransitionOnTriggerDown[4]	= "Fire";

	stateName[5]                    = "StopFire";
	stateTransitionOnTimeout[5]     = "Ready";
	stateTimeoutValue[5]            = 0.2;
	stateAllowImageChange[5]        = false;
	stateWaitForTimeout[5]		= true;
	stateSequence[5]                = "StopFire";
	stateScript[5]                 = "onStopFire";
};

function SGWrenchImage::onPreFire(%this, %obj, %slot)
{
	//messageAll( 'MsgClient', 'SGWrench prefired!!!');
	//Parent::onFire(%this, %obj, %slot);
	%obj.playthread(2, armattack);
}

function SGWrenchImage::onStopFire(%this, %obj, %slot)
{	
	%obj.playthread(2, root);
	//messageAll( 'MsgClient', 'stopfire');
}

function removeFromMoverList(%obj)
{
	for(%t = 0; %t < $TotalMoversPlaced + 1; %t++)
	{
		if(%obj == $Movers[%t])
		{
			$Movers[%t] = 0;
		}
	} 
}

function SGWrenchProjectile::onCollision(%this,%obj,%col,%fade,%pos,%normal)
{
	if(%col.sg)
		return;

		%client = %obj.client;
		if(%obj.client.isImprisoned)
		{
		messageClient(%client,'',"\c4Trying to SGWrench are you?!?! Imprisoned scum...");
		return;
		}
		%player = %obj.client.player;

		//if theres no player, (or client) bail out now
		if(!%player)
			return;
		
		if (%col.getClassName() !$= "StaticShape" && %col.getClassName() !$= "Player")
			return;

		%colData = %col.getDataBlock();
		%colDataClass = %colData.classname;

		if(%colDataClass $= "brick")
		{
        //If we are hitting a brick - check the SGWrench mode and apply appropiate action

        //Dial out brick
	    if(%obj.client.SGWrenchMode == 0)
		{
        if(%col.issgdialout)
        {
        %col.issgdialout=0;
        %col.isStarGateBrick=0;
        messageclient(%client,"","Brick is no longer a dial out");
        }
        else
        {
        %col.issgdialout=1;
        %col.isStarGateBrick=1;
        messageclient(%client,"","Brick is now a dial out");
        }
		}

		//Assign brick to a CTF base
        if(%obj.client.SGWrenchMode == 1)
        {
        if(%col.isctfbase)
        {
		%player.isctfing=0;
        %col.isctfbase=0;
		%col.ctfteam="";
		%col.hasflag=0;
        messageclient(%client,"","Brick is no longer a CTF base");
        }
        else
        {
        //%col.isctfbase=1;
		//%col.ctfteam="";
		%player.isctfing=1;
		%player.ctfbrick=%col;
		commandtoclient(%client,'OpenPWBox');
        messageclient(%client,"","Creating a CTF base");
        }
        }
		
        //Assign brick to a building spawn
        if(%obj.client.SGWrenchMode == 2)
        {
        if(%col.issgbuildspawn)
        {
        %col.issgbuildspawn=0;
        %col.isStarGateBrick=0;
        messageclient(%client,"","Brick is no longer a Stargate Buildings Spawn");
        }
        else
        {
        %col.issgbuildspawn=1;
        %col.isStarGateBrick=1;
        messageclient(%client,"","Brick is now a Stargate Buildings Spawn");
        // > Hit with StarGate wrench in Spawn Buildings mode to spawn stuff.
        }
        }

        //Spawn Buildings mode
        if(%obj.client.SGWrenchMode == 3)
        {
        if(%col.issgbuildspawn)
        {
        //Build time!
        %player.isspawningsgbuilds=1;
        //If we are spawning then build it!
        if(%player.isspawningsgbuilds)
        {
        sgbuildtime(%player,%col);
        return;
        }
        }	
		}

		if(%col.getClassName() $= "Player")
		{
            //If we are hitting a player
            //if(%obj.client.SGWrenchMode == 3)
            //{
                %col.applyRepair(10);
            //}
		}
}
}



function serverCmdToggleSGWrenchMode(%client)
{
	%client.SGWrenchMode++;
	if(%client.SGWrenchMode > 6)
	{
		%client.SGWrenchMode = 0;
	}
	if(%client.SGWrenchMode == 0)
	{
		messageClient(%client,"","\c5Stargate Wrench in Location / Dial Out Mode");
	}
	if(%client.SGWrenchMode == 1)
	{
		messageClient(%client,"","\c5Stargate Wrench in CTF-Base Mode NOT ACTIVE");
	}
	if(%client.SGWrenchMode == 2)
	{
		messageClient(%client,"","\c5Stargate Wrench in Building Spawn Mode");
	}
	if(%client.SGWrenchMode == 3)
	{
		messageClient(%client,"","\c5Stargate Wrench in Spawn Building Mode");
	}
	if(%client.SGWrenchMode == 4)
	{
		messageClient(%client,"","\c5Stargate Wrench in not-active mode ");
	}
	if(%client.SGWrenchMode == 5)
	{
		messageClient(%client,"","\c5Stargate Wrench in not-active mode");
	}
	if(%client.SGWrenchMode == 6)
	{
		messageClient(%client,"","\c5Stargate Wrench in Reset Mode");
	}
}

moveMap.bindCmd(keyboard, "ctrl n", "commandToServer('ToggleSGWrenchMode');", "");

moveMap.bindCmd(keyboard, "n", "openclose('SGWrenchM');", "");


function serverCmdToggleWrenchMode2(%client)
{
	%client.WrenchMode--;
	if(%client.WrenchMode < 0)
	{
		%client.WrenchMode = 8;
	}
	if(%client.WrenchMode == 0)
	{
		messageClient(%client,"","\c2Wrench in Mover-Mode");
	}
	if(%client.WrenchMode == 1)
	{
		messageClient(%client,"","\c2Wrench in Ezy-Mover-Mode");
	}
	if(%client.WrenchMode == 2)
	{
		messageClient(%client,"","\c2Wrench in Repair-Mode");
	}
	if(%client.WrenchMode == 3)
	{
		messageClient(%client,"","\c2Wrench in Brick-Message-Mode");
	}
	if(%client.WrenchMode == 4)
	{
		messageClient(%client,"","\c2Wrench in Brick-Decal-Mode");
	}
	if(%client.WrenchMode == 5)
	{
		messageClient(%client,"","\c2Wrench in Impulse-Mode");
	}
	if(%client.WrenchMode == 6)
	{
		messageClient(%client,"","\c2Wrench in Doorbell-Mode");
	}
	if(%client.WrenchMode == 7)
	{
		messageClient(%client,"","\c2Wrench in Camera Place Mode");
	}
	if(%client.WrenchMode == 8)
	{
		messageClient(%client,"","\c2Wrench in Camera View Mode");
	}
}	

function serverCmdToggleWrenchModeSet0(%client)
{
	%client.WrenchMode=0;
	messageClient(%client,"","\c2Wrench in Mover-Mode");
}	

function serverCmdToggleWrenchModeSet1(%client)
{
	%client.WrenchMode=1;
	messageClient(%client,"","\c2Wrench in Ezy-Mover-Mode");
}	

function serverCmdToggleWrenchModeSet2(%client)
{
	%client.WrenchMode=2;
	messageClient(%client,"","\c2Wrench in Repair-Mode");
}	

function serverCmdToggleWrenchModeSet3(%client)
{
	%client.WrenchMode=3;
	messageClient(%client,"","\c2Wrench in Brick-Message-Mode");
}	

function serverCmdToggleWrenchModeSet4(%client)
{
	%client.WrenchMode=4;
	messageClient(%client,"","\c2Wrench in Brick-Decal-Mode");
}	

function serverCmdToggleWrenchModeSet5(%client)
{
	%client.WrenchMode=5;
	messageClient(%client,"","\c2Wrench in Impulse-Mode");
}	

function serverCmdToggleWrenchModeSet6(%client)
{
	%client.WrenchMode=6;
	messageClient(%client,"","\c2Wrench in Doorbell-Mode");
}	

function serverCmdToggleWrenchModeSet7(%client)
{
	%client.WrenchMode=7;
	messageClient(%client,"","\c2Wrench in Camera Place Mode");
}	

function serverCmdToggleWrenchModeSet8(%client)
{
	%client.WrenchMode=8;
	messageClient(%client,"","\c2Wrench in Camera View Mode");
}	
